-- =====================================================
-- ʊ֐
-- 
-- t@C    : CommonFunc.lua
-- 
-- =====================================================

-- }bvIuWFNgƂ̏
function ExecObject( nID )

	return
	{
		GetMapObject( nID ).Exec()
	};
end


-- ׂ
function Speech( strMsg )
	coroutine.yield( expShowMessage(strMsg) )
end

-- ̍sɂׂ
function AddSpeech( strMsg )
	coroutine.yield( expAddMessage(strMsg) )
end


-- XJ
function OpenStore( nType, nMsgPtn, nRate, lstItem )
	-- nType   : X̃^Cv
	-- nMsgPtn : bZ[Wp^[
	-- nRate   : i (%)
	-- lstItem : iXg
	coroutine.yield( expOpenStore( nType, nMsgPtn, nRate, lstItem ) )
end

-- 󔠏
function TresureBox( nMapID, nID )
	local nFlag = expGetTreasureFlag( nMapID, nID )
	if nFlag == 0 then
		local strTresureName = expGetTreasure( nMapID, nID )
		Speech( strTresureName .. "" )
	else
		Speech( "ۂ" )
	end
	expCloseMessage()
end

-- tF[hAEg
function Fadeout( nR, nG, nB, nFrame )
	coroutine.yield( expStartFadeout( nR, nG, nB, nFrame ) )
end
-- tF[hC
function Fadein( nR, nG, nB, nFrame )
	coroutine.yield( expStartFadein( nR, nG, nB, nFrame ) )
end

-- ch
function ShakeVertical( nFrame, dblSpeed, nScale )
	coroutine.yield( expShake( 0, nFrame, dblSpeed, nScale ) )
end
-- h
function ShakeHorizontal( nFrame, dblSpeed, nScale )
	coroutine.yield( expShake( 1, nFrame, dblSpeed, nScale ) )
end


-- }bvؑ
-- yӁz̊֐̌ R[`폜܂
---        㑱̏Ȃł
function ChangeMap( nMapID, nX, nY, nDir )
	expChangeMap( nMapID, nX, nY, nDir )
end

-- v[Lɐi߂
function MovePlayerDown( nStepCnt, nSpeed )
	for i = 1, nStepCnt do
		coroutine.yield( expMovePlayer( 0, nSpeed ) )	--  1 : 
	end
end
-- v[Lɐi߂
function MovePlayerLeft( nStepCnt, nSpeed )
	for i = 1, nStepCnt do
		coroutine.yield( expMovePlayer( 1, nSpeed ) )	--  1 : 
	end
end
-- v[Lɐi߂
function MovePlayerUp( nStepCnt, nSpeed )
	for i = 1, nStepCnt do
		coroutine.yield( expMovePlayer( 2, nSpeed ) )	--  1 : 
	end
end
-- v[LEɐi߂
function MovePlayerRight( nStepCnt, nSpeed )
	for i = 1, nStepCnt do
		coroutine.yield( expMovePlayer( 3, nSpeed ) )	--  1 : 
	end
end

-- Lɐi߂
function MoveMapObjectDown( nID, nStepCnt, nSpeed )
	for i = 1, nStepCnt do
		coroutine.yield( expMoveMapObject( nID, 0, nSpeed ) )--  2 : 
	end
end

-- Lɐi߂
function MoveMapObjectLeft( nID, nStepCnt, nSpeed )
	for i = 1, nStepCnt do
		coroutine.yield( expMoveMapObject( nID, 1, nSpeed ) )--  2 : 
	end
end
-- Lɐi߂
function MoveMapObjectUp( nID, nStepCnt, nSpeed )
	for i = 1, nStepCnt do
		coroutine.yield( expMoveMapObject( nID, 2, nSpeed ) )--  2 : 
	end
end

-- Lɐi߂
function MoveMapObjectRight( nID, nStepCnt, nSpeed )
	for i = 1, nStepCnt do
		coroutine.yield( expMoveMapObject( nID, 3, nSpeed ) )--  2 : 
	end
end

-- ΂炭҂
function WaitFrame( nFrameCnt )
	coroutine.yield( expWaitFrame( nFrameCnt ) )		-- wt[҂
end

-- GJEg
function StartBattle( nEnemyPartyID )
	coroutine.yield( expStartBattle( nEnemyPartyID ) )	-- wGp[eBo
end

-- ͂/ _CAO
function ShowYesNoMessage( strMsg )
	coroutine.yield( expShowYesNoMessage( strMsg ) )	-- ͂/ _CAO
end

-- ґ _CAO
function ShowChoiceMessage( strQuestion, strAns1, strAns2, strAns3  )
	coroutine.yield( expShowChoiceMessage( strQuestion, strAns1, strAns2, strAns3 ) )	-- ґ _CAO
end
